﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace NumberGame {
  public partial class Form1 : Form {

    // a dictionary of messages to display on the output form:
      private Dictionary<Status, string> message = new Dictionary<Status, string>()
	    {   // there are four entries in the dictionary:
	      {Status.Start, "Let's play!\nChoose an int between 0 and 10"},
	      {Status.HaveMN, "You chose M.\nThe computer chooses N.\nChoose an int so that the three ints total 10."},
	                      // Hint: use the  Replace  method to replace "M" and "N"
          {Status.Win, "You Win!  Press button to play again."},
	      {Status.Lose, "You Lose!  Game is over."}
	    };
        
    private ButtonHandler handler;  // method to call when there is a button press
    private Status state;  // current state of the game

    // constructor method
    // params:  f - method to call when there is a button press
    //          initstate - the starting state of the game
    public Form1(ButtonHandler f, Status initstate) {
      this.handler = f;
      this.state = initstate;
      InitializeComponent();
    }

    // initialize the label:
    private void Form1_Load(object sender, EventArgs e)
    { label1.Text = message[state]; }
   
    // handles a button press by calling handler and refreshing
    // the Form based on the new state of the game
    private void button1_Click(object sender, EventArgs e) {
      string s = textBox1.Text;
      Tuple<Status, int> pair = handler(s);
      state = pair.Item1;
      int num = pair.Item2;
      textBox1.Text = "";
      // FINISH ME: use  state  to display appropriate message.     
      

    }
    
  }

}
